import { DialogSOP } from '../../libappsop/dialogsop';
import { EditFieldSOP } from '../../libappsop/editfieldsop';

export interface DialogGoalFields {
  Weight?: string;
  Level?: string;
}

export class DialogGoal extends DialogSOP<DialogGoalFields> {
  public static readonly title = 'Goal';

  public efWeight = new EditFieldSOP('EditFieldWeight');
  public efLevel = new EditFieldSOP('EditFieldLevel');

  public constructor() {
    // Provide dialog name for button as the dialog opens on top of strategy dialog
    // So that clicks the right button
    super('DialogEditKPIWeight', 'DialogEditKPIWeight.btnOk', 'DialogEditKPIWeight.btnCancel');

    // Set UI element mapping to pair the UI name to the UI element for use in DialogSOP to find the UI object to set value or verify value
    // This prevents each new Dialog to duplicate code just to set/verify UI element value
    this._uiMap.set('Weight', this.efWeight);
    this._uiMap.set('Level', this.efLevel);
  }
}
